// SetMode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include "SetModeIntf.h"

int main(int argc, char* argv[])
{
	int nMode, nFirst=0, nLast=GetModesCount()-1, nRes = 0, nPortNum;
	BOOL bEn;
	char* buf[8];

	if (argc > 1)
	{
		nMode = atoi(argv[1]);
		char cMode;
		_itoa(nMode,&cMode,10);
		if (cMode == *argv[1] && nFirst < nMode && nMode < nLast)
			nFirst = nLast = nMode;
		else
		{
			printf("Invalid command line parameter (%s)\n\nUsage:\nSetMode.exe N\t- Init mode N=(0..ModesCount)\nSetMode.exe\t- test all modes\n\n", argv[1]);
			nLast = -1;
		}
	}
//////////////////////////////////////////////////////////////////////////
	for (int i = nFirst; i <= nLast; i++)
//////////////////////////////////////////////////////////////////////////
	{
		memset(buf,0,32);
		if (GetModeInfo(i, (char*)buf, 8, &bEn, &nPortNum))
		{
			printf("Mode %d - %s, %sabled", i, (char*)buf, bEn?"en":"dis");
			if (nPortNum > 0)
				printf(", restricted to port %d\n", nPortNum);
			else printf("\n");
		}
		else
			printf("Mode %d - GetInfo() failed\n", i);

//////////////////////////////////////////////////////////////////////////
		nRes = SetMode(i);
//////////////////////////////////////////////////////////////////////////

		if (nRes != i)
			printf("init failed (current mode %d)\n\n", nRes);
		else
			printf("init done\n\n");
	}
	printf("Press [ENTER]");
	getchar();
	return 0;
}
